using System;
using UnityEngine;
using System.Collections;

public class Bike : MonoBehaviour {

	private BikeStatus bikeStat = new BikeStatus();
	private Core core = new Core();

	private float moveSpeed = 10;
    private float turnSpeed = 45;

    // Use this for initialization
    void Start () {
        this.core.start();
    }

	// Update is called once per frame
	void FixedUpdate () { 
		this.manageUserInteractions(transform);
		// this.updateBikeStatus(transform);
		this.updateCore(transform);
    }

	private void manageUserInteractions(Transform tf) {
		if (Input.GetKey(KeyCode.UpArrow)) {
            tf.Translate(Vector3.forward * moveSpeed * Time.deltaTime);
			//if(this.bikeStat.getGearRatio() < BikeStatus.MAX_GEAR_RATIO)
				//this.bikeStat.setGearRatio(this.bikeStat.getGearRatio()+1);
		}

		if (Input.GetKey(KeyCode.DownArrow)) {
            tf.Translate(-Vector3.forward * moveSpeed * Time.deltaTime);
			//if(this.bikeStat.getGearRatio() > 0)
				//this.bikeStat.setGearRatio(this.bikeStat.getGearRatio()-1);
		}

        if (Input.GetKey(KeyCode.LeftArrow))
            tf.Rotate(Vector3.up, -turnSpeed * Time.deltaTime);

		if (Input.GetKey(KeyCode.RightArrow))
            tf.Rotate(Vector3.up, turnSpeed * Time.deltaTime);

		if (Input.GetKey(KeyCode.F1))
            this.bikeStat.setGearRatio(0);

		if (Input.GetKey(KeyCode.F2))
            this.bikeStat.setGearRatio(1);

		if (Input.GetKey(KeyCode.F3))
            this.bikeStat.setGearRatio(2);

		if (Input.GetKey(KeyCode.F4))
            this.bikeStat.setGearRatio(3);

		if (Input.GetKey(KeyCode.F5))
            this.bikeStat.setGearRatio(4);

		if (Input.GetKey(KeyCode.Q))
            this.core.setVelRatio(1);

		if (Input.GetKey(KeyCode.W))
            this.core.setVelRatio(1.25f);

		if (Input.GetKey(KeyCode.E))
            this.core.setVelRatio(1.5f);

		if (Input.GetKey(KeyCode.R))
            this.core.setVelRatio(2);

		if (Input.GetKey(KeyCode.T))
            this.core.setVelRatio(3);

		if (Input.GetKey(KeyCode.Y))
            this.core.setVelRatio(4);

		if (Input.GetKey(KeyCode.U))
            this.core.setVelRatio(5);

		if (Input.GetKey(KeyCode.Escape))
            this.end();

		if (Input.GetKey(KeyCode.Mouse0))
            tf.Rotate(Vector3.up, -turnSpeed * Time.deltaTime);

		if (Input.GetKey(KeyCode.Mouse1))
            tf.Rotate(Vector3.up, turnSpeed * Time.deltaTime);
	}

	private void updateBikeStatus(Transform tf) {
		this.bikeStat.updateStatus(tf);
	}

	private void updateCore(Transform tf) {
		this.updateBikeStatus(tf);
		this.core.update(this.bikeStat);
	}

	private void end() {
		this.core.end();
		Application.Quit();
	}
}
