using System;
using UnityEngine;

public class BikeStatus {

	private Transform bikeTransform = null;
	private float bikeDegreesRotationX = 0;
	private int gearRatio = 0;

	public static readonly int MAX_GEAR_RATIO = 4; 

	public BikeStatus() {}

	public BikeStatus(Transform tf) {

		this.updateStatus(tf);

	}

	public void updateStatus(Transform tf) {

		this.bikeTransform = tf;
		this.bikeDegreesRotationX = tf.eulerAngles.x >= 180 ? 360 - tf.eulerAngles.x : - tf.eulerAngles.x;

	}

	public Transform getBikeTransform() {
		return this.bikeTransform;
	}

	public float getBikeDegreesRotationX() {
		return this.bikeDegreesRotationX;
	}

	public void setGearRatio(int gearRatio) {
		this.gearRatio = gearRatio;
	}

	public int getGearRatio() {
		return this.gearRatio;
	}
}
