using System;
using System.Text;
using System.Threading;

public class JavaDriverManager : DriverManager {

	private EDProtocol protocol = new EDProtocol("0","0");

	private bool pendingSendingRequest = false;
    private bool pendingReadingRequest = false;

	public static readonly String SOCKET_IP_ADDRESS = "127.0.0.1"; //TODO: configuration
    public static readonly int SOCKET_PORT = 11111; //TODO: configuration
    public static readonly Encoding SOCKET_ENCODING = Encoding.ASCII; //TODO: configuration
    public static readonly String SOCKET_EOC_STRING = "<EOC>"; //TODO: configuration

	public JavaDriverManager() {}

	public void start() {
		if(AsynchronousSocketCommunicationManager.Listen(JavaDriverManager.SOCKET_IP_ADDRESS, JavaDriverManager.SOCKET_PORT, JavaDriverManager.SOCKET_ENCODING, JavaDriverManager.SOCKET_EOC_STRING)) {
			//TODO: init
		} else {
			throw new Exception("[JavaDriverManager]-->[start()]: AsynchronousSocketCommunicationManager.Listen failed");
		}
	}

	public EDProtocol synchronize(EDProtocol protocol) {
		if(AsynchronousSocketCommunicationManager.IsConnected()) {
			if(!pendingSendingRequest && !pendingReadingRequest) {
				pendingSendingRequest = AsynchronousSocketCommunicationManager.Send(protocol.getProtocolString());
			} else if(pendingSendingRequest && !pendingReadingRequest && AsynchronousSocketCommunicationManager.IsSended()) {
				if(AsynchronousSocketCommunicationManager.Read()) {
					pendingSendingRequest = false;
					pendingReadingRequest = true;
				}
			} else if(!pendingSendingRequest && pendingReadingRequest && AsynchronousSocketCommunicationManager.IsReaded()) {
				this.protocol = new EDProtocol(AsynchronousSocketCommunicationManager.GetContent());
				pendingReadingRequest = false;
			}
		}
		return this.protocol;
	}

	public void end() {
		if(AsynchronousSocketCommunicationManager.IsConnected()) {
			AsynchronousSocketCommunicationManager.Send(EDProtocol.EOR.ToString());
			Thread.Sleep(200);
		}
		if(AsynchronousSocketCommunicationManager.Close()) {
			//TODO: end
		} else {
			throw new Exception("[JavaDriverManager]-->[end()]: AsynchronousSocketCommunicationManager.Close failed");
		}
	}

	public EDProtocol getProtocol() {
		return this.protocol;
	}

}
